unit DrugReport;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Menus, ComCtrls, DrugActivityDates, HepCLibrary,
  MFunStr, Dialogs, HepCCommon;

type
  TdlgDrugReport = class(TForm)
    btnOK: TButton;
    StatusBar1: TStatusBar;
    btnPrint: TButton;
    pnlMain: TPanel;
    pnlDetails: TPanel;
    pnlReport: TPanel;
    listReport: TListView;
    PrintDialog1: TPrintDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    HepCRegistryHelp1: TMenuItem;
    Print1: TMenuItem;
    N1: TMenuItem;
    pnlDates: TPanel;
    lblStartDate: TLabel;
    edtStartDate: TEdit;
    lblEndDate: TLabel;
    edtEndDate: TEdit;
    pnlCreated: TPanel;
    lblCreated: TLabel;
    edtCreated: TEdit;
    procedure btnPrintClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure HepCRegistryHelp1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
    procedure setCreated;
  public
    { Public declarations }
    procedure setStartDate(StartDate:String);
    procedure setEndDate(EndDate:String);
    procedure setReportItem(Data:String);
  end;

var
  dlgDrugReport: TdlgDrugReport;

implementation

{$R *.DFM}

procedure TdlgDrugReport.setStartDate(StartDate:String);
begin
  if StartDate<>'' then edtStartDate.Text:=DateToStr(FMDateToWindowsDate(StartDate)) else edtStartDate.Text:='None';
end;

procedure TdlgDrugReport.setEndDate(EndDate:String);
begin
  if EndDate<>'' then edtEndDate.Text:=DateToStr(FMDateToWindowsDate(EndDate)) else edtEndDate.Text:='None';
end;

procedure TdlgDrugReport.setCreated;
begin
  edtCreated.Text:=DateToStr(Date);
end;

procedure TdlgDrugReport.btnPrintClick(Sender: TObject);
begin
  if PrintDialog1.Execute then PrintDrugReport;
end;

procedure TdlgDrugReport.Exit1Click(Sender: TObject);
begin
  Application.Terminate;
  Exit;
end;

procedure TdlgDrugReport.setReportItem(Data:String);
var
  i:Integer;
  Item:TListItem;
begin
  Item:=listReport.Items.Add;
  Item.Caption:=Piece(Data,'^',1);
  for i:=2 to 6 do
  begin
      Item.SubItems.Add(Piece(Data,'^',i));
  end;
end;

procedure TdlgDrugReport.FormShow(Sender: TObject);
begin
  setCreated;
end;

procedure TdlgDrugReport.HepCRegistryHelp1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER,0);
end;

procedure TdlgDrugReport.FormResize(Sender: TObject);
begin
  pnlMain.Height:=self.ClientHeight-90;
  btnOK.Top:=self.ClientHeight-60;
  btnPrint.Top:=self.ClientHeight-60;
end;

end.
