unit HepC;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, ComCtrls, ToolWin, Trpcb, HepCLibrary, ImgList, IniFiles,
  MFunStr, PtSelect, MessageBox,
  LocRegPatRep, ManPatEdit, ManPatActive, ManIDrug, VA_AboutDlg, RegistryInfo, ActivityLog, DrugActivityDates,
  AppEvnts;

type
  TfrmHepC = class(TForm)
    mnuMain: TMainMenu;
    RPC: TRPCBroker;
    sbMain: TStatusBar;
    mnuFile: TMenuItem;
    mnuHelp: TMenuItem;
    ImageList1: TImageList;
    About1: TMenuItem;
    N1: TMenuItem;
    RegistryInfo1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    mnuPrint: TMenuItem;
    mnuAddEdit: TMenuItem;
    mnuActivate: TMenuItem;
    mnuDrugs: TMenuItem;
    mnuLog: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    mnuDrugList: TMenuItem;
    LogOff1: TMenuItem;
    HepatitisCRegistryHelp1: TMenuItem;
    N5: TMenuItem;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    tbtnRegRep: TToolButton;
    tbtnDrugList: TToolButton;
    tbtnManEntry: TToolButton;
    tbtnPatAct: TToolButton;
    tbtnPatDrug: TToolButton;
    tbtnLog: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure tbtnRegRepClick(Sender: TObject);
    procedure tbtnManEntryClick(Sender: TObject);
    procedure tbtnPatActClick(Sender: TObject);
    procedure tbtnPatDrugClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure RegistryInfo1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure tbtnLogClick(Sender: TObject);
    procedure tbtnDrugListClick(Sender: TObject);
    procedure LogOff1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HepatitisCRegistryHelp1Click(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateStatusBar(Connection:String;NTName:String;VistaName:String);
    procedure UpdateIniFile;
    procedure UnloadIniFile;
    procedure AllocateOptions;
  public
    { Public declarations }
  end;

var
  frmHepC: TfrmHepC;
  dlgLocRegPatRep: TdlgLocRegPatRep;
  dlgDrugDates:TdlgDrugDates;
  dlgManPatEdit:TdlgManPatEdit;
  dlgManPatActive:TdlgManPatActive;
  dlgManIDrug:TdlgManIDrug;
  dlgLog:TdlgLog;
  dlgRegInfo:TdlgRegInfo;
  AboutDlg:TAboutDlg;

implementation

uses PatientSearch, HepCCommon;

{$R *.DFM}

procedure TfrmHepC.UnloadIniFile;
var
  S:String;
begin
  S:=GetGUISettings(RPC,'frmHepC');
  if Piece(S,';',5)='Maximized' then frmHepC.WindowState:=wsMaximized
  else
  begin
    frmHepC.WindowState:=wsNormal;
    if Piece(S,';',1)<>'' then frmHepC.Top:=StrToInt(Piece(S,';',1));
    if Piece(S,';',2)<>'' then frmHepC.Left:=StrToInt(Piece(S,';',2));
    if Piece(S,';',3)<>'' then frmHepC.Width:=StrToInt(Piece(S,';',3));
    if Piece(S,';',4)<>'' then frmHepC.Height:=StrToInt(Piece(S,';',4));
    frmHepC.Resize;
  end;
end;

procedure TfrmHepC.UpdateIniFile;
var
  S:String;
begin
  S:=IntToStr(frmHepC.Top)+';'+
     IntToStr(frmHepC.Left)+';'+
     IntToStr(frmHepC.Width)+';'+
     IntToStr(frmHepC.Height)+';';
  if frmHepC.WindowState=wsMaximized then S:=S+'Maximized' else S:=S+'Normal';
  SetGUISettings(RPC,'frmHepC',S);
end;

procedure TfrmHepC.UpdateStatusBar(Connection:String;NTName:String;VistaName:String);
begin
  sbMain.Panels[0].Text:=Connection;
  sbMain.Panels[1].Text:=VistaName;
end;

procedure TfrmHepC.AllocateOptions;
begin
  tbtnRegRep.Enabled:=True;
  mnuPrint.Enabled:=True;
  tbtnDrugList.Enabled:=True;
  mnuDrugList.Enabled:=True;
  tbtnManEntry.Enabled:=Administrator;
  mnuAddEdit.Enabled:=Administrator;
  tbtnPatAct.Enabled:=Administrator;
  mnuActivate.Enabled:=Administrator;
  tbtnPatDrug.Enabled:=Administrator;
  mnuDrugs.Enabled:=Administrator;
  tbtnLog.Enabled:=True;
  mnuLog.Enabled:=True;
end;

procedure TfrmHepC.FormCreate(Sender: TObject);
var
  Connection,NTName,VistaName,Cnt:String;
begin
  PatList:=TStringList.Create;
  ReportData:=TStringList.Create;
  DrugReportData:=TStringList.Create;
  HepCActivityLog:=TStringList.Create;
  LogOntoVista(RPC,RPCContext,Connection,NTName,VistaName);
  if RPC.Connected then
  begin
    UpdateStatusBar(Connection,NTName,VistaName);
    CallRPCGetParams(RPC,LastUpdate,LastExtract,Cnt);
    UnloadIniFile;
    AllocateOptions;
  end;
end;

procedure TfrmHepC.tbtnRegRepClick(Sender: TObject);
begin
  dlgLocRegPatRep:=TdlgLocRegPatRep.Create(Application);
  dlgLocRegPatRep.ShowModal;
  dlgLocRegPatRep.Destroy;
end;

procedure TfrmHepC.tbtnManEntryClick(Sender: TObject);
begin
  dlgManPatEdit:=TdlgManPatEdit.Create(Application);
  dlgPatientSearch.FileNumber:='2';
  dlgPatientSearch.pnlScreenDate.Visible:=False;
  while dlgPatientSearch.ShowModal=mrOK do
  begin
    if PatientSelect(RPC,getPatientIEN) then
      if dlgManPatEdit.CallRPCPatientDetails(RPC,getPatientIEN) then
      begin
        dlgManPatEdit.ShowModal;
        dlgPatientSearch.Timer1Timer(Sender);
      end;
  end;
  dlgPatientSearch.edtSearch.Text:='';
  dlgPatientSearch.listOptions.Items.Clear;
  dlgManPatEdit.Destroy;
end;

procedure TfrmHepC.tbtnPatActClick(Sender: TObject);
begin
  dlgManPatActive:=TdlgManPatActive.Create(Application);
  dlgPatientSearch.FileNumber:='798';
  dlgPatientSearch.ShowScreenPanel(True);
  if dlgPatientSearch.cbScreen.Checked then dlgPatientSearch.Timer1Timer(Sender);
  while dlgPatientSearch.ShowModal=mrOK do
  begin
    if PatientSelect(RPC,getPatientIEN) then
      if dlgManPatActive.CallRPCPatientDetails(RPC,getPatientIEN) then
      begin
        dlgManPatActive.ShowModal;
        dlgPatientSearch.Timer1Timer(Sender);
      end;
  end;
  dlgPatientSearch.edtSearch.Text:='';
  dlgPatientSearch.listOptions.Items.Clear;
  dlgPatientSearch.ShowScreenPanel(False);
  dlgManPatActive.Destroy;
end;

procedure TfrmHepC.tbtnPatDrugClick(Sender: TObject);
begin
  dlgManIDrug:=TdlgManIDrug.Create(Application);
  dlgPatientSearch.FileNumber:='798';
  dlgPatientSearch.pnlScreenDate.Visible:=False;
  while dlgPatientSearch.ShowModal=mrOK do
  begin
    if PatientSelect(RPC,getPatientIEN) then
    if dlgManIDrug.CallRPCPatientDetails(RPC,getPatientIEN) then
    begin
      dlgManIDrug.ShowModal;
      dlgPatientSearch.Timer1Timer(Sender);
    end;
  end;
  dlgPatientSearch.edtSearch.Text:='';
  dlgPatientSearch.listOptions.Items.Clear;
  dlgManIDrug.Destroy;
end;

procedure TfrmHepC.About1Click(Sender: TObject);
begin
  AboutDlg:=TAboutDlg.Create(Application);
  AboutDlg.ShowModal;
  AboutDlg.Destroy;
end;

procedure TfrmHepC.RegistryInfo1Click(Sender: TObject);
begin
  dlgRegInfo:=TdlgRegInfo.Create(Application);
  dlgRegInfo.ShowModal;
  dlgRegInfo.Destroy;
end;

procedure TfrmHepC.Exit1Click(Sender: TObject);
begin
  Application.Terminate;
  Exit;
end;

procedure TfrmHepC.tbtnLogClick(Sender: TObject);
begin
  dlgLog:=TdlgLog.Create(Application);
  dlgLog.ShowModal;
  dlgLog.Destroy;
end;

procedure TfrmHepC.tbtnDrugListClick(Sender: TObject);
begin
  dlgDrugDates:=TdlgDrugDates.Create(Application);
  dlgDrugDates.ShowModal;
  dlgDrugDates.Destroy;
end;

procedure TfrmHepC.LogOff1Click(Sender: TObject);
var
  Connection,NTName,VistaName,Cnt:String;
begin
  RPC.Connected:=False;
  LogOntoVista(RPC,RPCContext,Connection,NTName,VistaName);
  if RPC.Connected then
  begin
    UpdateStatusBar(Connection,NTName,VistaName);
    CallRPCGetParams(RPC,LastUpdate,LastExtract,Cnt);
  end;
end;

procedure TfrmHepC.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  UpdateIniFile;
  PatList.Free;
  ReportData.Free;
  DrugReportData.Free;
  HepCActivityLog.Free;
end;

procedure TfrmHepC.HepatitisCRegistryHelp1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER,0);
end;

end.
