unit HepCLibrary;

interface

uses SysUtils, Stdctrls, Classes, Dialogs,
     TRpcb, MFunStr,
     Windows, Messages, Graphics,
     Controls, Forms, Rpcconf1,
     Menus, ComCtrls, ExtCtrls, MessageBox;

const RegistryName = 'VA HEPC';
      RPCContext = 'ROR GUI MENU';

function NTGetUserName:String;
function GetVistAUserName(RPC:TRPCBroker;UserIEN:String):String;
function GetVistAUserInfo(RPC:TRPCBroker;Ref:String):String;
function GetUserType(RPC:TRPCBroker):Boolean;
function WindowsDateToFMDate(WindowsDate:TDate):String;
function WindowsTimeToFMTime(WindowsTime:TDateTime):String;
function FMDateToWindowsDate(FMDate:String):TDate;
function FMTimeToWindowsTime(FMTime:String):TDateTime;
function ConstructDate(Year:Integer;Month:Integer;Day:Integer):String;
function ConstructTime(FMTime:String):String;
function CallRPCGetCodes(RPC:TRPCBroker;CodeType:String):TStrings;
function GetGUISettings(RPC:TRPCBroker;CtrlName:String):String;
procedure SetGUISettings(RPC:TRPCBroker;CtrlName,Value:String);
procedure LogOntoVistA(RPC:TRPCBroker;Context:String;var Connection:String;var NTName:String;var VistaName:String);
procedure CallRPCGetParams(RPC:TRPCBroker;var LastUpdate:String;var LastExtract:String;var PatCount:String);
procedure displayError(ErrMessage:String;ErrType:TMsgDlgType);

var
  UserDUZ:String;
  Administrator:Boolean;
  PatList:TStrings;
  ReportData,DrugReportData:TStrings;
  LastUpdate,LastExtract,RegistryDescription:String;
  HepCActivityLog:TStrings;

implementation

function WindowsDateToFMDate(WindowsDate:TDate):String;
var
  FMM2,FMD2:String;
  FMY,FMM,FMD:Word;
begin
  DecodeDate(WindowsDate,FMY,FMM,FMD);
  if Length(IntToStr(FMM))=1 then FMM2:='0'+IntToStr(FMM) else FMM2:=IntToStr(FMM);
  if Length(IntToStr(FMD))=1 then FMD2:='0'+IntToStr(FMD) else FMD2:=IntToStr(FMD);
  Result:=IntToStr(FMY-1700)+FMM2+FMD2;
end;

function WindowsTimeToFMTime(WindowsTime:TDateTime):String;
var
  FMH2,FMM2,FMS2,FMX2:String;
  FMH,FMM,FMS,FMX:Word;
begin
  DecodeTime(WindowsTime,FMH,FMM,FMS,FMX);
  if Length(IntToStr(FMH))=1 then FMH2:='0'+IntToStr(FMH) else FMH2:=IntToStr(FMH);
  if Length(IntToStr(FMM))=1 then FMM2:='0'+IntToStr(FMM) else FMM2:=IntToStr(FMM);
  if Length(IntToStr(FMS))=1 then FMS2:='0'+IntToStr(FMS) else FMS2:=IntToStr(FMS);
  Result:=FMH2+FMM2+FMS2;
  if Length(Result)=5 then Result:='0'+Result;
end;

function FMDateToWindowsDate(FMDate:String):TDate;
var
  FMY,FMM,FMD:Word;
begin
  FMY:=1700+StrToInt(Copy(FMDate,1,3));
  FMM:=StrToInt(Copy(FMDate,4,2));
  FMD:=StrToInt(Copy(FMDate,6,2));
  Result:=EncodeDate(FMY,FMM,FMD);
end;

function FMTimeToWindowsTime(FMTime:String):TDateTime;
var
  FMH,FMM,FMS:Word;
begin
  if Length(FMTime)<6 then FMTime:=FMTime+Copy('000000',1,6-Length(FMTime));
  FMH:=StrToInt(Copy(FMTime,1,2));
  FMM:=StrToInt(Copy(FMTime,3,2));
  FMS:=StrToInt(Copy(FMTime,5,2));
  Result:=EncodeTime(FMH,FMM,FMS,0);
end;

function ConstructDate(Year:Integer;Month:Integer;Day:Integer):String;
var
  tmpDate:TDate;
begin
  tmpDate:=EncodeDate(Year,Month,Day);
  Result:=WindowsDateToFMDate(tmpDate);
end;

function ConstructTime(FMTime:String):String;
begin
  Result:=FMTime;
  if Length(Result)<6 then Result:=Result+Copy('000000',1,6-Length(Result));
end;

procedure LogOntoVistA(RPC:TRPCBroker;Context:String;var Connection:String;var NTName:String;var VistaName:String);
var
  i:Integer;
  ServerString,PortString:String;
begin
  ServerString:='';
  PortString:='';
  if ParamCount > 0 then
  begin
    for i:=1 to ParamCount do
    begin
      if UpperCase(Piece(ParamStr(i),'=',1))='P' then
        PortString:=Piece(ParamStr(i),'=',2)
      else if UpperCase(Piece(ParamStr(i),'=',1))='S' then
        ServerString:=Piece(ParamStr(i),'=',2);
    end;
  end;
  if ((ServerString='') or (StrToIntDef(PortString,0)=0)) then
  begin
    if GetServerInfo(ServerString,PortString)=mrCancel then
    begin
      Application.Terminate;
      Exit;
    end;
  end;
  RPC.Server:=ServerString;
  RPC.ListenerPort:=StrToInt(PortString);
  try RPC.Connected:=True;
    if RPC.Socket > 0 then
    begin//User Connected/Logged on properly - File #19 Check
      if RPC.CreateContext(Context)=False then
      begin//User was not assigned menu option
        displayError('You are not a valid user of '+Context+'. Terminating Application...',mtError);
        Application.Terminate;
        Exit;
      end
      else
      begin//XWB GET VARIABLE VALUE Call
        Connection:='Connected: '+RPC.Server+' @ '+IntToStr(RPC.ListenerPort);
        NTName:='NT Name: '+NTGetUserName;
        VistaName:='VISTA Name: '+GetVISTAUserName(RPC,GetVistAUserInfo(RPC,'DUZ'));
        if GetUserType(RPC)=False then
        begin
          displayError('You do not hold a valid key for this application. Terminating Application...',mtError);
          Application.Terminate;
          Exit;
        end;
      end;
    end
    else
    begin
      displayError('Invalid Logon. Terminating Application...',mtError);
      Application.Terminate;
      Exit;
    end;
  except on EBrokerError do
    begin
      displayError('Connection to the Server - '+RPC.Server+
      ' - could not be established. Terminating Application...',mtError);
      Application.Terminate;
      Exit;
    end;
  end;
end;

function NTGetUserName:String;
var
  lpBuffer:lpstr;
  success:Boolean;
  nSize:DWord;
begin
  nSize:=255;
  Result:='';
  GetMem(lpBuffer,255);
  try success:=GetUserName(lpBuffer,nSize);
  if not success then Result:='Unknown NT User' else Result:=StrPas(lpBuffer);
  finally FreeMem(lpBuffer);
  end;
end;

function GetVISTAUserName(RPC:TRPCBroker;UserIEN:String):String;
begin
  RPC.RemoteProcedure:='XUS GET USER INFO';
  try RPC.Call;
  if RPC.Results.Count>1 then Result:= RPC.Results[1] else Result:='';
  except on EBrokerError do Result:='';
  end;
end;

function GetVistAUserInfo(RPC:TRPCBroker;Ref:String):String;
begin
  RPC.RemoteProcedure:='XWB GET VARIABLE VALUE';
  RPC.Param[0].PType:=Reference;
  RPC.Param[0].Value:=Ref;
  try RPC.Call;
  if RPC.Results.Count>0 then Result:=RPC.Results[0] else Result:='';
  except on EBrokerError do Result:='';
  end;
  UserDUZ:=Result;
end;

function GetUserType(RPC:TRPCBroker):Boolean;
begin
  Result:=False;
  Administrator:=False;
  RPC.RemoteProcedure:='XUS KEY CHECK';
  RPC.Param[0].PType:=List;
  RPC.Param[0].Mult['1']:='ROR '+RegistryName+' USER';
  RPC.Param[0].Mult['2']:='ROR '+RegistryName+' ADMIN';
  try RPC.Call;
  if RPC.Results.Count>0 then
  begin
    if RPC.Results[0]='1' then Result:=True;
    if RPC.Results[1]='1' then
    begin
      Result:=True;
      Administrator:=True;
    end;
  end;
  except on EBrokerError do Result:=False;
  end;
end;

procedure CallRPCGetParams(RPC:TRPCBroker;var LastUpdate:String;var LastExtract:String;var PatCount:String);
begin
  RPC.RemoteProcedure:='ROR REG PARAMS GET';
  RPC.Param[0].PType:=Literal;
  RPC.Param[0].Value:=RegistryName;
  try RPC.Call;
    if RPC.Results.Count>0 then
    begin
      if RPC.Results[0]<>'0' then
      begin
        RegistryDescription:=RPC.Results[1];
        if RPC.Results[2]<>'' then LastUpdate:=DateToStr(FMDateToWindowsDate(RPC.Results[2])) else LastUpdate:='';
        if RPC.Results[3]<>'' then LastExtract:=DateToStr(FMDateToWindowsDate(RPC.Results[3])) else LastExtract:='';
        PatCount:=RPC.Results[4];
      end
      else displayError('Broker Error: Invalid Registry Name',mtError);
    end
    else displayError('Broker Error: Failed to retrieve Registry Parameters',mtError);
  except on EBrokerError do displayError('Broker Error: Failed to retrieve Registry Parameters',mtError);
  end;
end;

function CallRPCGetCodes(RPC:TRPCBroker;CodeType:String):TStrings;
begin
  Result:=TStringList.Create;
  Result.Clear;
  with RPC do
  begin
    Results.Clear;
    RemoteProcedure:='ROR GET CODE LIST';
    Param[0].PType:=Literal;
    Param[0].Value:=RegistryName;
    Param[1].PType:=Literal;
    Param[1].Value:=CodeType;
    try Call;
      if Results.Count>0 then
      begin
        Result.AddStrings(Results);
      end
      else displayError('Broker Error: Failed to retrieve code list',mtError);
    except on EBrokerError do displayError('Broker Error: Failed to retrieve code list',mtError);
    end;
  end;
end;

procedure displayError(ErrMessage:String;ErrType:TMsgDlgType);
var
  emsg:TStrings;
begin
  emsg:=TStringList.Create;
  emsg.Clear;
  emsg.Add('Hepatitis C Registry');
  emsg.Add('');
  emsg.Add(ErrMessage);
  ShowMessage(ErrType,emsg);
  emsg.Free;
end;

function GetGUISettings(RPC:TRPCBroker;CtrlName:String):String;
begin
  with RPC do
  begin
    RemoteProcedure:='ROR GET GUI PARAMS';
    Param[0].PType:=Literal;
    Param[0].Value:=RegistryName;
    Param[1].PType:=Literal;
    Param[1].Value:=CtrlName;
    try Call;
      if Results.Count>0 then Result:=Results[0];
    except on EBrokerError do displayError('Broker Error: Failed to retrieve saved settings',mtError);
    end;
  end;
end;

procedure SetGUISettings(RPC:TRPCBroker;CtrlName,Value:String);
begin
  with RPC do
  begin
    RemoteProcedure:='ROR SET GUI PARAMS';
    Param[0].PType:=Literal;
    Param[0].Value:=RegistryName;
    Param[1].PType:=Literal;
    Param[1].Value:=CtrlName;
    Param[2].PType:=Literal;
    Param[2].Value:=Value;
    try Call;
    except on EBrokerError do displayError('Broker Error: Failed to save user settings',mtError);
    end;
  end;
end;

end.

