unit LocRegPatRep;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, ComCtrls, Dialogs, MFunStr, Printers, Menus,
  TRpcB, FileCtrl, IniFiles, MessageBox, HepCCommon,  dlgReportStatus;

type
  TdlgLocRegPatRep = class(TForm)
    sbMain: TStatusBar;
    btnCancel: TButton;
    pnlRight: TPanel;
    grpSortBy: TGroupBox;
    rdoName: TRadioButton;
    rdoDOB: TRadioButton;
    rdoDateEntered: TRadioButton;
    rdoDateInact: TRadioButton;
    rdoDateReact: TRadioButton;
    rdoDrugs: TRadioButton;
    pnlLeft: TPanel;
    pnlTimePeriod: TPanel;
    grpTimePeriod: TRadioGroup;
    cmbQuarterly: TComboBox;
    pnlYear: TPanel;
    LeftLine: TBevel;
    cmbYear: TComboBox;
    pnlDates: TPanel;
    grpDates: TGroupBox;
    dtpStartDate: TDateTimePicker;
    dtpEndDate: TDateTimePicker;
    pnlDateRange: TPanel;
    grpDateRange: TRadioGroup;
    pnlActive: TPanel;
    grpActive: TRadioGroup;
    cbStartDate: TCheckBox;
    cbEndDate: TCheckBox;
    PrintDialog1: TPrintDialog;
    SaveDialog1: TSaveDialog;
    lblYear: TLabel;
    lblStartDate: TLabel;
    lblEndDate: TLabel;
    rdoDFN: TRadioButton;
    rdoICN: TRadioButton;
    grpPrevRun: TGroupBox;
    lblLastUpdate: TLabel;
    edtUpdate: TEdit;
    lblTransmit: TLabel;
    edtExtract: TEdit;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    HepCRegistryHelp1: TMenuItem;
    N1: TMenuItem;
    SaveReport1: TMenuItem;
    DisplayReport1: TMenuItem;
    PrintReport1: TMenuItem;
    Timer1: TTimer;
    pnlInfo: TPanel;
    grpAddFields: TGroupBox;
    cbDOB: TCheckBox;
    cbDateEntered: TCheckBox;
    cbDateInact: TCheckBox;
    cbDateReact: TCheckBox;
    cbDrugs: TCheckBox;
    cbReason: TCheckBox;
    cbInactReason: TCheckBox;
    cbDFN: TCheckBox;
    cbICN: TCheckBox;
    grpButtons: TGroupBox;
    btnShow: TBitBtn;
    btnExport: TBitBtn;
    btnReport: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure grpDateRangeClick(Sender: TObject);
    procedure grpTimePeriodClick(Sender: TObject);
    procedure cbDOBClick(Sender: TObject);
    procedure cbDateEnteredClick(Sender: TObject);
    procedure cbDateInactClick(Sender: TObject);
    procedure cbDateReactClick(Sender: TObject);
    procedure cbDrugsClick(Sender: TObject);
    procedure cbStartDateClick(Sender: TObject);
    procedure cbEndDateClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbDFNClick(Sender: TObject);
    procedure cbICNClick(Sender: TObject);
    procedure btnExportClick(Sender: TObject);
    procedure btnReportClick(Sender: TObject);
    procedure btnShowClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HepCRegistryHelp1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    procedure DisplayPrevRunInfo;
    procedure ExportReport(FileName:String);

    function GetStartDate:String;
    procedure setStartDate(StartDate:String);
    function GetEndDate:String;
    procedure setEndDate(EndDate:String);
    function GetSortBy:Integer;
    procedure setSortBy(SortBy:Integer);
    procedure setAdditionalFields(AddFlds:String);
    procedure setActiveInactive(ActiveInactive:Integer);
    procedure setDateRange(DateRange:Integer);
    function getDateRange:Integer;
    function CallRPCReportText:TStrings;
    function FormatReportLine(DataString,Fields:String):String;
    procedure UpdateIniFile;
    procedure UnloadIniFile;
    procedure CallRPCTaskRegistry(StartDate,EndDate,ActiveInactive,SortBy,AddFlds:String);
  public
    { Public declarations }
    procedure DisplayReport;
    function GetAdditionalFields:String;
    procedure GetStartEndDates(var StartDate:String;var EndDate:String);
    function GetActiveInactive:String;
    function GetSortByName:String;
    procedure printHeader(var Line:Integer);
    procedure ReportLineToCanvas(var Line:Integer;DataString,Fields:String;Bold:Boolean);
    procedure CallRPCGetHandle(var Hndl:TRPCHandle);
  end;

var
  dlgLocRegPatRep: TdlgLocRegPatRep;
  RepStatusDlg: TRepStatusDlg;
  RPCHandle: TRPCHandle;

implementation

{$R *.DFM}

uses HepCLibrary, Report, HepC;

procedure TdlgLocRegPatRep.UnloadIniFile;
var
S,AddFlds,AddFlds2:String;
i:Integer;
begin
  S:=GetGUISettings(frmHepC.RPC,'dlgLocRegPatRep');
  if Piece(S,';',1)<>'' then setSortBy(StrToInt(Piece(S,';',1))) else setSortBy(0);
  if Piece(S,';',2)<>'' then
  begin
    AddFlds:=Piece(S,';',2);
    AddFlds2:='';
    for i:=1 to 9 do
    begin
      AddFlds2:=AddFlds2+Copy(AddFlds,i,1)+'^';
    end;
    setAdditionalFields(AddFlds2)
  end
  else setAdditionalFields('0^0^0^0^0^0^0^0^0');
  if Piece(S,';',3)<>'' then setActiveInactive(StrToInt(Piece(S,';',3))) else setActiveInactive(1);
  if Piece(S,';',4)<>'' then setDateRange(StrToInt(Piece(S,';',4))) else setDateRange(0);
  setEndDate(Piece(S,';',5));
  setStartDate(Piece(S,';',6));
end;

procedure TdlgLocRegPatRep.UpdateIniFile;
var
AI,i:Integer;
S,AddFlds,AddFlds2:String;
begin
  if getActiveInactive='B' then AI:=0 else if getActiveInactive='A' then AI:=1 else AI:=2;
  AddFlds:=getAdditionalFields;
  AddFlds2:='';
  for i:=1 to 9 do
  begin
    AddFlds2:=AddFlds2+Piece(AddFlds,'^',i);
  end;
  S:=IntToStr(GetSortBy)+';'+
     AddFlds2+';'+
     IntToStr(AI)+';'+
     IntToStr(getDateRange)+';'+
     getEndDate+';'+
     getStartDate;
  SetGUISettings(frmHepC.RPC,'dlgLocRegPatRep',S);
end;

procedure TdlgLocRegPatRep.DisplayPrevRunInfo;
begin
  if LastUpdate<>'' then edtUpdate.Text:=LastUpdate else edtUpdate.Text:='Never';
  if LastExtract<>'' then edtExtract.Text:=LastExtract else edtExtract.Text:='Never';
end;

function TdlgLocRegPatRep.GetStartDate:String;
begin
  if cbStartDate.Checked then Result:='' else Result:=WindowsDateToFMDate(dtpStartDate.Date);
end;

procedure TdlgLocRegPatRep.setStartDate(StartDate:String);
begin
  if StartDate<>'' then dtpStartDate.Date:=FMDateToWindowsDate(StartDate) else
  begin
    try dtpStartDate.Date:=StrToDate(LastExtract);
    except on EConvertError do;
    end;
    cbStartDate.Checked:=True;
  end;
end;

function TdlgLocRegPatRep.GetEndDate:String;
begin
  if cbEndDate.Checked then Result:='' else Result:=WindowsDateToFMDate(dtpEndDate.Date);
end;

procedure TdlgLocRegPatRep.setEndDate(EndDate:String);
begin
  if EndDate<>'' then dtpEndDate.Date:=FMDateToWindowsDate(EndDate) else
  begin
    dtpEndDate.Date:=Date;
    cbEndDate.Checked:=True;
  end;
end;

procedure TdlgLocRegPatRep.GetStartEndDates(var StartDate:String;var EndDate:String);
var
  Year:Integer;
begin
  if grpDateRange.ItemIndex=0 then
  begin
    StartDate:=GetStartDate;
    EndDate:=GetEndDate;
  end
  else
  begin
    Year:=StrToInt(cmbYear.Items[cmbYear.ItemIndex]);
    case grpTimePeriod.ItemIndex of
    0:
      begin
        StartDate:=ConstructDate(Year,1,1);
        EndDate:=ConstructDate(Year,12,31);
      end;
    1:
      begin
        StartDate:=ConstructDate(Year-1,10,1);
        EndDate:=ConstructDate(Year,9,30);
      end;
    2:
      begin
        case cmbQuarterly.ItemIndex of
        0:
          begin
            StartDate:=ConstructDate(Year,1,1);
            EndDate:=ConstructDate(Year,3,31);
          end;
        1:
          begin
            StartDate:=ConstructDate(Year,4,1);
            EndDate:=ConstructDate(Year,6,30);
          end;
        2:
          begin
            StartDate:=ConstructDate(Year,7,1);
            EndDate:=ConstructDate(Year,9,30);
          end;
        3:
          begin
            StartDate:=ConstructDate(Year,10,1);
            EndDate:=ConstructDate(Year,12,31);
          end;
        end;
      end;
    end;
  end;
end;

function TdlgLocRegPatRep.getDateRange:Integer;
begin
  Result:=grpDateRange.ItemIndex;
end;

procedure TdlgLocRegPatRep.setDateRange(DateRange:Integer);
begin
  grpDateRange.ItemIndex:=DateRange;
end;

function TdlgLocRegPatRep.GetActiveInactive:String;
begin
  Result:=Copy(grpActive.Items[grpActive.ItemIndex],1,1);
end;

procedure TdlgLocRegPatRep.setActiveInactive(ActiveInactive:Integer);
begin
  grpActive.ItemIndex:=ActiveInactive;
end;

function TdlgLocRegPatRep.GetAdditionalFields:String;
begin
  Result:='';
  if cbDFN.Checked then Result:='1^' else Result:='0^';
  if cbICN.CHecked then Result:=Result+'1^' else Result:=Result+'0^';
  if cbDOB.Checked then Result:=Result+'1^' else Result:=Result+'0^';
  if cbDateEntered.Checked then Result:=Result+'1^' else Result:=Result+'0^';
  if cbDateInact.Checked then Result:=Result+'1^' else Result:=Result+'0^';
  if cbInactReason.Checked then Result:=Result+'1^' else Result:=Result+'0^';
  if cbDateReact.Checked then Result:=Result+'1^' else Result:=Result+'0^';
  if cbDrugs.Checked then Result:=Result+'1^' else Result:=Result+'0^';
  if cbReason.Checked then Result:=Result+'1^' else Result:=Result+'0^';
end;

procedure TdlgLocRegPatRep.setAdditionalFields(AddFlds:String);
begin
  if Piece(AddFlds,'^',1)='1' then cbDFN.Checked:=True else cbDFN.Checked:=False;
  if Piece(AddFlds,'^',2)='1' then cbICN.Checked:=True else cbICN.Checked:=False;
  if Piece(AddFlds,'^',3)='1' then cbDOB.Checked:=True else cbDOB.Checked:=False;
  if Piece(AddFlds,'^',4)='1' then cbDateEntered.Checked:=True else cbDateEntered.Checked:=False;
  if Piece(AddFlds,'^',5)='1' then cbDateInact.Checked:=True else cbDateInact.Checked:=False;
  if Piece(AddFlds,'^',6)='1' then cbInactReason.Checked:=True else cbInactReason.Checked:=False;
  if Piece(AddFlds,'^',7)='1' then cbDateReact.Checked:=True else cbDateReact.Checked:=False;
  if Piece(AddFlds,'^',8)='1' then cbDrugs.Checked:=True else cbDrugs.Checked:=False;
  if Piece(AddFlds,'^',9)='1' then cbReason.Checked:=True else cbReason.Checked:=False;
end;

function TdlgLocRegPatRep.GetSortBy:Integer;
begin
  Result:=-1;
  if rdoName.Checked then Result:=0
  else if rdoDFN.Checked then Result:=1
  else if rdoICN.Checked then Result:=2
  else if rdoDOB.Checked then Result:=3
  else if rdoDateEntered.Checked then Result:=4
  else if rdoDateInact.Checked then Result:=5
  else if rdoDateReact.Checked then Result:=6
  else if rdoDrugs.Checked then Result:=7;
end;

procedure TdlgLocRegPatRep.setSortBy(SortBy:Integer);
begin
  rdoName.Checked:=(SortBy=0);
  rdoDFN.Checked:=(SortBy=1);
  rdoICN.Checked:=(SortBy=2);
  rdoDOB.Checked:=(SortBy=3);
  rdoDateEntered.Checked:=(SortBy=4);
  rdoDateInact.Checked:=(SortBy=5);
  rdoDateReact.Checked:=(SortBy=6);
  rdoDrugs.Checked:=(SortBy=7);
end;

function TdlgLocRegPatRep.GetSortByName:String;
begin
  if rdoName.Checked then Result:=rdoName.Caption
  else if rdoDFN.Checked then Result:=rdoDFN.Caption
  else if rdoICN.Checked then Result:=rdoICN.Caption
  else if rdoDOB.Checked then Result:=rdoDOB.Caption
  else if rdoDateEntered.Checked then Result:=rdoDateEntered.Caption
  else if rdoDateInact.Checked then Result:=rdoDateInact.Caption
  else if rdoDateReact.Checked then Result:=rdoDateReact.Caption
  else if rdoDrugs.Checked then Result:=rdoDrugs.Caption;
end;

function TdlgLocRegPatRep.FormatReportLine(DataString,Fields:String):String;
var
  i:Integer;
begin
  Result:='';
  Result:=Piece(DataString,'^',1)+#9+Piece(DataString,'^',2)+#9+Piece(DataString,'^',3);
  for i:=1 to 9 do
  begin
    if Piece(Fields,'^',i)='1' then Result:=Result+#9+Piece(DataString,'^',i+3);
  end;
end;

procedure TdlgLocRegPatRep.ReportLineToCanvas(var Line:Integer;DataString,Fields:String;Bold:Boolean);
var
  LeftPos,ColWidth,i:Integer;
begin
  //put blank line in before each patient
  if Piece(DataString,'^',1)<>'' then
  begin
    Line:=Line+1;
    if ((80*Line)>Printer.PageHeight) then
    begin
      Printer.NewPage;
      printHeader(Line);
    end;
  end;
  if Bold then Printer.Canvas.Font.Style:=[fsBold];
  Printer.Canvas.TextOut(0,80*(Line-1),Piece(DataString,'^',1));
  Printer.Canvas.TextOut(130,80*(Line-1),Copy(Piece(DataString,'^',2),1,35));
  Printer.Canvas.TextOut(1360,80*(Line-1),Piece(DataString,'^',3));
  LeftPos:=1680;
  ColWidth:=520;
  for i:=1 to 9 do
  begin
    if Piece(Fields,'^',i)='1' then
    begin
      if i<>1 then LeftPos:=LeftPos+ColWidth;
      if i=7 then
      begin
        if Piece(Fields,'^',6)='1' then LeftPos:=LeftPos+ColWidth+(ColWidth div 2);
      end;
      if i=8 then
      begin
        if ((Piece(Fields,'^',6)='1') and (Piece(Fields,'^',7)='0')) then LeftPos:=LeftPos+ColWidth+(ColWidth div 2);
      end;
      if i=9 then
      begin
        if ((Piece(Fields,'^',6)='1') and (Piece(Fields,'^',7)='0') and (Piece(Fields,'^',8)='0')) then LeftPos:=LeftPos+ColWidth+(ColWidth div 2);
        if Piece(Fields,'^',8)='1' then LeftPos:=LeftPos-(ColWidth div 2);
      end;
      Printer.Canvas.TextOut(LeftPos,80*(Line-1),Piece(DataString,'^',3+i));
    end;
  end;
  if Bold then Printer.Canvas.Font.Style:=[];
  Line:=Line+1;
  if ((80*Line)>Printer.PageHeight) then
  begin
    Printer.NewPage;
    printHeader(Line);
  end;
end;

procedure TdlgLocRegPatRep.printHeader(var Line:Integer);
var
  StartDate,EndDate,ActiveInactive,AddFlds,SortBy:String;
  str:String;
  chrw,chrh:Integer;
begin
  GetStartEndDates(StartDate,EndDate);
  ActiveInactive:=GetActiveInactive;
  AddFlds:=GetAdditionalFields;
  SortBy:=GetSortByName;
  //
  str:='Hepatitis C Local Registry';
  chrw:=Printer.Canvas.TextExtent(str).cx;
  chrh:=Printer.Canvas.TextExtent(str).cy;
  Printer.Canvas.Font.Style:=[fsBold,fsUnderline];
  Printer.Canvas.TextOut((Printer.PageWidth-chrw) div 2,0,str);
  Printer.Canvas.Font.Style:=[];
  str:='Page: '+IntToStr(Printer.PageNumber);
  chrw:=Printer.Canvas.TextExtent(str).cx;
  Printer.Canvas.TextOut(Printer.PageWidth-chrw,0,str);
  //
  if Printer.PageNumber=1 then
  begin
    Printer.Canvas.TextOut(0,chrh*2,'Sorted By: '+SortBy);
    str:='Report Created: '+DateToStr(Date);
    chrw:=Printer.Canvas.TextExtent(str).cx;
    Printer.Canvas.TextOut(Printer.PageWidth-chrw,chrh*2,str);
    //
    str:='Start Date: ';
    if StartDate<>'' then str:=str+DateToStr(FMDateToWindowsDate(StartDate)) else str:=str+' None';
    str:=str+'   '+'End Date: ';
    if EndDate<>'' then str:=str+DateToStr(FMDateToWindowsDate(EndDate)) else str:=str+' None';
    Printer.Canvas.TextOut(0,chrh*3,str);
    str:='Local Registry Last Updated: '+LastUpdate;
    chrw:=Printer.Canvas.TextExtent(str).cx;
    Printer.Canvas.TextOut(Printer.PageWidth-chrw,chrh*3,str);
    //
    str:='Report on: ';
    if ActiveInactive='B' then str:=str+'Both Active & Ina' else if ActiveInactive='I' then str:=str+'Ina' else str:=str+'A';
    str:=str+'ctive patients.';
    Printer.Canvas.TextOut(0,chrh*4,str);
    str:='Data Last Extracted and Transmitted: '+LastExtract;
    chrw:=Printer.Canvas.TextExtent(str).cx;
    Printer.Canvas.TextOut(Printer.PageWidth-chrw,chrh*4,str);
    //
    Line:=6;
  end
  else Line:=2;
  ReportLineToCanvas(Line,'^NAME^LAST^PATIENT^PATIENT^DATE^DATE^DATE^REASON^DATE^INV.^REASON(S)',AddFlds,True);
  ReportLineToCanvas(Line,'^^FOUR^DFN^ICN^OF BIRTH^ENTERED^INACTIVATED^INACTIVATED^REACTIVATED^DRUGS^ADDED',AddFlds,True);
end;

function TdlgLocRegPatRep.CallRPCReportText:TStrings;
var
  i,cnt:Integer;
  PCnt:String;
begin
  cnt:=0;
  Timer1.Enabled:=False;
  Result:=TStringList.Create;
  Result.Clear;
  CallRPCGetParams(frmHepC.RPC,LastUpdate,LastExtract,PCnt);
  DisplayPrevRunInfo;
  if ((RPCHandle.ID<>'') and (RPCHandle.TaskStatus='Completed Successfully')) then
  begin
    with frmHepC.RPC do
    begin
      RemoteProcedure:='XWB DEFERRED GETDATA';
      Param[0].PType:=Literal;
      Param[0].Value:=RPCHandle.ID;
      try Call;
        if Results.Count>0 then
        begin
          for i:=0 to Results.Count-1 do
          begin
            if Piece(Results[i],'^',1)<>'' then
            begin
              cnt:=cnt+1;
              Result.Add(IntToStr(cnt)+'^'+Results[i]);
            end
            else Result.Add('^'+Results[i]);
          end;
        end
        else Result.Add('^Nothing to report.');
      except on EBrokerError do displayError('Broker Error: Failed to retrieve report info',mtError);
      end;
    end;
  end
  else if ((RPCHandle.ID<>'') and (RPCHandle.TaskStatus='Running')) then displayError('Previously scheduled report still running',mtError)
  else displayError('Failed to retrieve report info.',mtError);
end;

procedure TdlgLocRegPatRep.FormShow(Sender: TObject);
var
  i:Integer;
  Dy,Mn,Yr:Word;
  PCnt:String;
begin
  //Display Previous Run Information
  CallRPCGetParams(frmHepC.RPC,LastUpdate,LastExtract,PCnt);
  DisplayPrevRunInfo;
  //Default Date & Time Pickers
  dtpStartDate.MaxDate:=Date;
  //Populate Year ComboBox
  DecodeDate(Date,Yr,Mn,Dy);
  for i:=2000 to Yr+100 do cmbYear.Items.Add(IntToStr(i));
  cmbYear.ItemIndex:=cmbYear.Items.IndexOf(IntToStr(Yr));
  //
end;

procedure TdlgLocRegPatRep.grpDateRangeClick(Sender: TObject);
begin
  if grpDateRange.ItemIndex=0 then
  begin
    pnlTimePeriod.Visible:=False;
    pnlDates.Top:=37;
    pnlDates.Visible:=True;
  end
  else
  begin
    pnlDates.Visible:=False;
    pnlDates.Top:=37;
    pnlTimePeriod.Visible:=True;
  end;
end;

procedure TdlgLocRegPatRep.grpTimePeriodClick(Sender: TObject);
var
  Dy,Mn,Yr:Word;
begin
  if grpTimePeriod.ItemIndex=2 then
  begin
    DecodeDate(Date,Yr,Mn,Dy);
    case Mn of
      1..3: cmbQuarterly.ItemIndex:=0;
      4..6: cmbQuarterly.ItemIndex:=1;
      7..9: cmbQuarterly.ItemIndex:=2;
      10..12: cmbQuarterly.ItemIndex:=3;
    end;
    cmbQuarterly.Enabled:=True;
    cmbQuarterly.SetFocus;
  end
  else cmbQuarterly.Enabled:=False;
end;

procedure TdlgLocRegPatRep.cbDOBClick(Sender: TObject);
begin
  if (not cbDOB.Checked) then if rdoDOB.Checked then rdoName.Checked:=True;
  rdoDOB.Enabled:=cbDOB.Checked;
end;

procedure TdlgLocRegPatRep.cbDateEnteredClick(Sender: TObject);
begin
  if (not cbDateEntered.Checked) then if rdoDateEntered.Checked then rdoName.Checked:=True;
  rdoDateEntered.Enabled:=cbDateEntered.Checked;
end;

procedure TdlgLocRegPatRep.cbDateInactClick(Sender: TObject);
begin
  if (not cbDateInact.Checked) then if rdoDateInact.Checked then rdoName.Checked:=True;
  rdoDateInact.Enabled:=cbDateInact.Checked;
end;

procedure TdlgLocRegPatRep.cbDateReactClick(Sender: TObject);
begin
  if (not cbDateReact.Checked) then if rdoDateReact.Checked then rdoName.Checked:=True;
  rdoDateReact.Enabled:=cbDateReact.Checked;
end;

procedure TdlgLocRegPatRep.cbDrugsClick(Sender: TObject);
begin
  if (not cbDrugs.Checked) then if rdoDrugs.Checked then rdoName.Checked:=True;
  rdoDrugs.Enabled:=cbDrugs.Checked;
end;

procedure TdlgLocRegPatRep.cbStartDateClick(Sender: TObject);
begin
  dtpStartDate.Enabled:=(not cbStartDate.Checked);
end;

procedure TdlgLocRegPatRep.cbEndDateClick(Sender: TObject);
begin
  dtpEndDate.Enabled:=(not cbEndDate.Checked);
end;

procedure TdlgLocRegPatRep.mnuExitClick(Sender: TObject);
begin
  dlgLocRegPatRep.modalResult:=mrCancel;
end;

procedure TdlgLoCRegPatRep.ExportReport(FileName:String);
var
  SaveText:TextFile;
  //StartDate,EndDate,ActiveInactive,
  AddFlds:String;
  //SortBy,
  Index:Integer;
  ReportText:TStrings;
begin
  ReportText:=TStringList.Create;
  ReportText.Clear;
  //GetStartEndDates(StartDate,EndDate);
  //ActiveInactive:=GetActiveInactive;
  //SortBy:=GetSortBy;
  AddFlds:=GetAdditionalFields;
  ReportData:=CallRPCReportText;
  //
  ReportText.Add(FormatReportLine('^NAME^LAST FOUR^PATIENT DFN^PATIENT ICN^DATE OF BIRTH^DATE ENTERED^DATE INACTIVATED^REASON INACTIVATED^DATE REACTIVATED^INVESTIGATIONAL DRUGS^REASON ADDED',AddFlds));
  for Index:=0 to ReportData.Count-1 do
  begin
    ReportText.Add(FormatReportLine(ReportData[Index],AddFlds));
  end;
  AssignFile(SaveText,FileName);
  Rewrite(SaveText);
  Write(SaveText,ReportText.Text);
  CloseFile(SaveText);
  //
  ReportText.Free;
end;

procedure TdlgLocRegPatRep.DisplayReport;
var
  StartDate,EndDate,ActiveInactive,AddFlds:String;
  SortBy,Index:Integer;
  dlgReport:TdlgReport;
begin
  GetStartEndDates(StartDate,EndDate);
  ActiveInactive:=GetActiveInactive;
  SortBy:=GetSortBy;
  AddFlds:=GetAdditionalFields;
  ReportData:=CallRPCReportText;
  //
  dlgReport:=TdlgReport.Create(self);
  dlgReport.setSortedBy(GetSortByName);
  dlgReport.setStartDate(StartDate);
  dlgReport.setEndDate(EndDate);
  dlgReport.setReport(ActiveInactive);
  dlgReport.listReport.Items.Clear;
  dlgReport.CreateColumns(AddFlds);
  for Index:=0 to ReportData.Count-1 do
  begin
    dlgReport.setReportItem(ReportData[Index],AddFlds);
  end;
  //
  dlgReport.ShowModal;
  dlgReport.Destroy;
end;

procedure TdlgLocRegPatRep.FormCreate(Sender: TObject);
begin
  self.UnloadIniFile;
  RPCHandle:=TRPCHandle.Create;
  RepStatusDlg:=TRepStatusDlg.Create(self);
end;

procedure TdlgLocRegPatRep.cbDFNClick(Sender: TObject);
begin
  if (not cbDFN.Checked) then if rdoDFN.Checked then rdoName.Checked:=True;
  rdoDFN.Enabled:=cbDFN.Checked;
end;

procedure TdlgLocRegPatRep.cbICNClick(Sender: TObject);
begin
  if (not cbICN.Checked) then if rdoICN.Checked then rdoName.Checked:=True;
  rdoICN.Enabled:=cbICN.Checked;
end;

procedure TdlgLocRegPatRep.btnExportClick(Sender: TObject);
var
  StartDate,EndDate,ActiveInactive,AddFlds:String;
  SortBy:Integer;
begin
  if ((not cbStartDate.Checked) and (not cbEndDate.Checked)) and (getEndDate<getStartDate) then
  begin
    displayError('End date cannot be before start date',mtError);
    dtpStartDate.SetFocus;
    Exit;
  end;
  if SaveDialog1.Execute then
  begin
    if not DirectoryExists(ExtractFilePath(SaveDialog1.FileName)) then ForceDirectories(ExtractFilePath(SaveDialog1.FileName));
    //ExportReport(SaveDialog1.FileName);
    GetStartEndDates(StartDate,EndDate);
    ActiveInactive:=GetActiveInactive;
    SortBy:=GetSortBy;
    AddFlds:=GetAdditionalFields;
    RPCHandle.ID:='';
    RPCHandle.TaskStatus:='';
    RPCHandle.TaskID:='';
    CallRPCTaskRegistry(StartDate,EndDate,ActiveInactive,IntToStr(SortBy),AddFlds);
    Timer1.Enabled:=True;
    if RepStatusDlg.ShowModal=mrOK then ExportReport(SaveDialog1.FileName) else Timer1.Enabled:=False;;
  end;

{begin
  if ((not cbStartDate.Checked) and (not cbEndDate.Checked)) and (getEndDate<getStartDate) then
  begin
    displayError('End date cannot be before start date',mtError);
    dtpStartDate.SetFocus;
    Exit;
  end;
  if SaveDialog1.Execute then
  begin
    if not DirectoryExists(ExtractFilePath(SaveDialog1.FileName)) then ForceDirectories(ExtractFilePath(SaveDialog1.FileName));
    ExportReport(SaveDialog1.FileName);
  end;}
end;

procedure TdlgLocRegPatRep.btnReportClick(Sender: TObject);
var
  StartDate,EndDate,ActiveInactive,AddFlds:String;
  SortBy:Integer;
begin
  if ((not cbStartDate.Checked) and (not cbEndDate.Checked)) and (getEndDate<getStartDate) then
  begin
    displayError('End date cannot be before start date',mtError);
    dtpStartDate.SetFocus;
    Exit;
  end;
  if PrintDialog1.Execute then
  begin
    GetStartEndDates(StartDate,EndDate);
    ActiveInactive:=GetActiveInactive;
    SortBy:=GetSortBy;
    AddFlds:=GetAdditionalFields;
    RPCHandle.ID:='';
    RPCHandle.TaskStatus:='';
    RPCHandle.TaskID:='';
    CallRPCTaskRegistry(StartDate,EndDate,ActiveInactive,IntToStr(SortBy),AddFlds);
    Timer1.Enabled:=True;
    if RepStatusDlg.ShowModal=mrOK then
    begin
      ReportData:=CallRPCReportText;
      PrintReport;
    end
    else Timer1.Enabled:=False;
  end;
end;

procedure TdlgLocRegPatRep.btnShowClick(Sender: TObject);
var
  StartDate,EndDate,ActiveInactive,AddFlds:String;
  SortBy:Integer;
begin
  if ((not cbStartDate.Checked) and (not cbEndDate.Checked)) and (getEndDate<getStartDate) then
  begin
    displayError('End date cannot be before start date',mtError);
    dtpStartDate.SetFocus;
    Exit;
  end;
  GetStartEndDates(StartDate,EndDate);
  ActiveInactive:=GetActiveInactive;
  SortBy:=GetSortBy;
  AddFlds:=GetAdditionalFields;
  RPCHandle.ID:='';
  RPCHandle.TaskStatus:='';
  RPCHandle.TaskID:='';
  CallRPCTaskRegistry(StartDate,EndDate,ActiveInactive,IntToStr(SortBy),AddFlds);
  Timer1.Enabled:=True;
  if RepStatusDlg.ShowModal=mrOK then DisplayReport else Timer1.Enabled:=False;;
end;

procedure TdlgLocRegPatRep.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  self.UpdateIniFile;
end;

procedure TdlgLocRegPatRep.HepCRegistryHelp1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER,0);
end;

procedure TdlgLocRegPatRep.Exit1Click(Sender: TObject);
begin
  Application.Terminate;
  Exit;
end;

procedure TdlgLocRegPatRep.CallRPCTaskRegistry(StartDate,EndDate,ActiveInactive,SortBy,AddFlds:String);
begin
  with frmHepC.RPC do
  begin
    RemoteProcedure:='XWB DEFERRED RPC';
    Param[0].PType:=Literal;
    Param[0].Value:='ROR REPORT';
    Param[1].PType:=Literal;
    Param[1].Value:=RegistryName;
    Param[2].PType:=Literal;
    Param[2].Value:=StartDate;
    Param[3].PType:=Literal;
    Param[3].Value:=EndDate;
    Param[4].PType:=Literal;
    Param[4].Value:=ActiveInactive;
    Param[5].PType:=Literal;
    Param[5].Value:=SortBy;
    Param[6].PType:=Literal;
    Param[6].Value:=AddFlds;
    try Call;
      if Results.Count>0 then
      begin
        if Piece(Results[0],'^',1)<>'-1' then
        begin
          RPCHandle.ID:=Results[0];
          RPCHandle.TaskStatus:='Placed on TaskMan queue';
        end
        else displayError('Broker Error: '+Piece(Results[0],'^',2),mtError);
      end
      else displayError('Broker Error: Failed to schedule report compilation on TaskMan',mtError);
    except on EBrokerError do displayError('Broker Error: Failed to schedule report compilation on TaskMan',mtError);
    end;
  end;
  if RPCHandle.ID<>'' then RPCHandle.CallRPCStoreHandle('18');
  CallRPCGetHandle(RPCHandle);
end;

procedure TdlgLocRegPatRep.CallRPCGetHandle(var Hndl:TRPCHandle);
begin
  Hndl.CallRPCGetHandle('18');
  RepStatusDlg.Animate1.Active:=(Hndl.TaskStatus='Running');
  RepStatusDlg.edtStatus.Text:=Hndl.TaskStatus;
  RepStatusDlg.edtTaskID.Text:=Hndl.TaskID;
  if (Hndl.TaskStatus='Completed Successfully') then RepStatusDlg.ModalResult:=mrOK;
end;

procedure TdlgLocRegPatRep.FormDestroy(Sender: TObject);
begin
  RPCHandle.Free;
  RepStatusDlg.Free;
end;

procedure TdlgLocRegPatRep.btnOKClick(Sender: TObject);
var
  StartDate,EndDate,ActiveInactive,AddFlds:String;
  SortBy:Integer;
begin
  if ((not cbStartDate.Checked) and (not cbEndDate.Checked)) and (getEndDate<getStartDate) then
  begin
    displayError('End date cannot be before start date',mtError);
    dtpStartDate.SetFocus;
    Exit;
  end;
end;

procedure TdlgLocRegPatRep.Timer1Timer(Sender: TObject);
begin
  CallRPCGetHandle(RPCHandle);
end;

end.
