unit MessageBox;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls, Dialogs;

type
  TdlgMessage = class(TForm)
    btnYes: TButton;
    btnNo: TButton;
    btnOK: TButton;
    bmpMessage: TImage;
    edtMessage: TMemo;
  end;

function ShowMessage(BoxType:TMsgDlgType;Mess:TStrings):TModalResult;

var
  dlgMessage: TdlgMessage;

implementation

{$R *.DFM}

function ShowMessage(BoxType:TMsgDlgType;Mess:TStrings):TModalResult;
var
  MsgBmp:TBitMap;
  dlgMessage:TdlgMessage;
begin
  dlgMessage:=TdlgMessage.Create(Application);
  MsgBmp:=TBitmap.Create;
  MsgBmp.Transparent:=True;
  MsgBmp.TransparentMode:=tmAuto;
  //
  with dlgMessage do
  begin
    btnYes.Visible:=False;
    btnNo.Visible:=False;
    btnOK.Visible:=True;
    ActiveControl:=btnOK;
    case BoxType of
      mtError:
      begin
        Caption:='Error';
        MsgBmp.LoadFromResourceName(HInstance, 'ERRORICON');
      end;
      mtWarning:
      begin
        Caption:='Warning';
        MsgBmp.LoadFromResourceName(HInstance, 'WARNINGICON');
      end;
      mtInformation:
      begin
        Caption:='Information';
        MsgBmp.LoadFromResourceName(HInstance, 'INFOICON');
      end;
      mtConfirmation:
      begin
        Caption:='Confirm';
        MsgBmp.LoadFromResourceName(HInstance, 'CONFIRMICON');
        btnYes.Visible:=True;
        btnNo.Visible:=True;
        btnOK.Visible:=False;
        ActiveControl:=btnYes;
      end;
    end;
    bmpMessage.Picture.Bitmap:=MsgBmp;
    //
    edtMessage.Clear;
    edtMessage.Lines.AddStrings(Mess);
    //
    Height:=80 + (Canvas.TextHeight('X') * (edtMessage.Lines.Count+2));
    if Height<95 then Height:=95;
    edtMessage.Height:=(Canvas.TextHeight('X') * (edtMessage.Lines.Count+2));
    btnYes.Top:=ClientHeight-40;
    btnNo.Top:=ClientHeight-40;
    btnOK.Top:=ClientHeight-40;
    Resize;
    //
    Position:=poDesktopCenter;
    Result:=ShowModal;
  end;
end;

end.
