unit PatientSearch;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls, TrpcB, MFunStr, Dialogs, Menus, ORCtrls;

type
  TdlgPatientSearch = class(TForm)
    btnCancel: TButton;
    Timer1: TTimer;
    StatusBar1: TStatusBar;
    btnOK: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    HepCRegistryHelp1: TMenuItem;
    pnlMain: TPanel;
    pnlScreenDate: TPanel;
    cbScreen: TCheckBox;
    dtpScreenDate: TDateTimePicker;
    pnlResults: TPanel;
    Label2: TLabel;
    edtSearch: TEdit;
    listOptions: TListView;
    procedure Timer1Timer(Sender: TObject);
    procedure edtSearchKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure dtpScreenDateChange(Sender: TObject);
    procedure cbScreenClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure listOptionsClick(Sender: TObject);
    procedure listOptionsKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnOKClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure HepCRegistryHelp1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    fSelIEN:String;
    fFileNo:String;
    fScrnDate:TDate;
    fSelName:String;
    fSelSSN:String;
    fSelDOB:String;
    property SelectedIEN:String read fSelIEN write fSelIEN;
    property SelectedName:String read fSelName write fSelName;
    property SelectedSSN:String read fSelSSN write fSelSSN;
    property SelectedDOB:String read fSelDOB write fSelDOB;
    property FileNumber:String read fFileNo write fFileNo;
    property ScreenDate:TDate read fScrnDate write fScrnDate;
    procedure ShowScreenPanel(TrueFalse:Boolean);
  end;

var
  dlgPatientSearch: TdlgPatientSearch;

implementation

uses HepCLibrary, HepC;

{$R *.DFM}

procedure TdlgPatientSearch.ShowScreenPanel(TrueFalse:Boolean);
begin
  if TrueFalse then
  begin
    pnlScreenDate.Visible:=True;
    pnlScreenDate.Top:=8;
    pnlResults.Top:=pnlScreenDate.Height+14;
    pnlResults.Height:=pnlMain.Height-pnlScreenDate.Height-22;
  end
  else
  begin
    pnlScreenDate.Visible:=False;
    pnlResults.Top:=8;
    pnlResults.Height:=pnlMain.Height-22;
  end;
end;

procedure TdlgPatientSearch.Timer1Timer(Sender: TObject);
var
  i:Integer;
  LItem:TListItem;
begin
  Timer1.Enabled:=False;
  listOptions.Items.Clear;
  with frmHepC.RPC do
  begin
    RemoteProcedure:='ROR PATIENT SEARCH';
    Param[0].PType:=Literal;
    Param[0].Value:=RegistryName;
    Param[1].PType:=Literal;
    Param[1].Value:=UpperCase(edtSearch.Text);
    Param[2].PType:=Literal;
    Param[2].Value:='1';
    Param[3].PType:=Literal;
    Param[3].Value:=fFileNo;
    Param[4].PType:=Literal;
    if cbScreen.Checked then Param[4].Value:=WindowsDateToFMDate(fScrnDate) else Param[4].Value:='';
    try Call;
      if Results.Count>0 then
      begin
        for i:=0 to Results.Count-1 do
        begin
         LItem:=listOptions.Items.Add;
         LItem.Caption:=Piece(Results[i],'^',1);
         LItem.SubItems.Add(Copy(Piece(Results[i],'^',2),1,3)+'-'+Copy(Piece(Results[i],'^',2),4,2)+'-'+Copy(Piece(Results[i],'^',2),6,(Length(Piece(Results[i],'^',2))-5)));
         LItem.SubItems.Add(Piece(Results[i],'^',3));
         LItem.SubItems.Add(Piece(Results[i],'^',4));
        end;
      end;
    except on EBrokerError do listOptions.Items.Clear;
    end;
  end;
end;

procedure TdlgPatientSearch.edtSearchKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Length(edtSearch.Text)>2 then
  begin
    if Key=vk_RETURN then Timer1Timer(Sender) else
    begin
      Timer1.Interval:=500;
      Timer1.Enabled:=True;
    end;
  end
  else Timer1.Enabled:=False;
end;

procedure TdlgPatientSearch.FormCreate(Sender: TObject);
begin
  fSelIEN:='';
  fSelName:='';
  fSelSSN:='';
  fSelDOB:='';
  fFileNo:='798';
  if LastUpdate<>'' then fScrnDate:=StrToDate(LastUpdate) else fScrnDate:=Date;
  dtpScreenDate.Date:=fScrnDate;
  ShowScreenPanel(False);
end;

procedure TdlgPatientSearch.dtpScreenDateChange(Sender: TObject);
begin
  Timer1.Enabled:=False;
  fScrnDate:=dtpScreenDate.Date;
  if ((cbScreen.Checked) and (Length(edtSearch.Text)>2)) then
  begin
    Timer1.Interval:=1000;
    Timer1.Enabled:=True;
  end;
end;

procedure TdlgPatientSearch.cbScreenClick(Sender: TObject);
begin
  dtpScreenDate.Enabled:=cbScreen.Checked;
  //if cbScreen.Checked then Timer1Timer(Sender);
end;

procedure TdlgPatientSearch.FormShow(Sender: TObject);
begin
  dlgPatientSearch.edtSearch.SetFocus;
end;

procedure TdlgPatientSearch.listOptionsClick(Sender: TObject);
begin
  if listOptions.SelCount>0 then
  begin
    fSelName:=listOptions.Selected.Caption;
    fSelIEN:=listOptions.Selected.SubItems[2];
    fSelSSN:=Translate(listOptions.Selected.SubItems[0],'-','');
    fSelDOB:=listOptions.Selected.SubItems[1];
    ModalResult:=mrOK;
  end;
end;

procedure TdlgPatientSearch.listOptionsKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if listOptions.SelCount>0 then
  begin
    if Key = vk_RETURN then
    begin
      fSelName:=listOptions.Selected.Caption;
      fSelIEN:=listOptions.Selected.SubItems[2];
      fSelSSN:=Translate(listOptions.Selected.SubItems[0],'-','');
      fSelDOB:=listOptions.Selected.SubItems[1];
      ModalResult:=mrOK;
    end
  end;
  btnOK.Enabled:=(listOptions.SelCount>0);
end;

procedure TdlgPatientSearch.btnOKClick(Sender: TObject);
begin
  if listOptions.SelCount>0 then
  begin
    fSelName:=listOptions.Selected.Caption;
    fSelIEN:=listOptions.Selected.SubItems[2];
    fSelSSN:=Translate(listOptions.Selected.SubItems[0],'-','');
    fSelDOB:=listOptions.Selected.SubItems[1];
  end;
end;

procedure TdlgPatientSearch.Exit1Click(Sender: TObject);
begin
  Application.Terminate;
  Exit;
end;

procedure TdlgPatientSearch.HepCRegistryHelp1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER,0);
end;

procedure TdlgPatientSearch.FormResize(Sender: TObject);
begin
  pnlMain.Height:=self.ClientHeight-90;
  btnOK.Top:=self.ClientHeight-60;
  btnCancel.Top:=self.ClientHeight-60;
end;

procedure TdlgPatientSearch.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  cbScreen.Checked:=False;
end;

end.
